#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
                     
#include "common.h"

#define MAXMOTDLINE 512
extern void bnckill (int reason);
extern int bewmstick (void);
extern sockprint(int fd,const char *format,...);
extern logprint(confetti *jr,const char *format,...);
extern int passwordokay (char *s, char *pass);
extern int do_connect (char *vhostname, char *hostname, u_short port, char *uname);
extern int thestat(char *buf,int len, struct cliententry *list_ptr);
extern struct cliententry *getclient(struct cliententry *list_ptr, int nfd);
extern struct cliententry *delclient(struct cliententry *client_ptr, int nfd);
extern void add_access (confetti *, accesslist *);
extern confetti *jack;
extern struct cliententry *headclient;

unsigned char motdb[MAXMOTDLINE];

char *helplist[] =
{
  "COMMANDS are /quote:     ex.) /quote conn bnc.irc.net 6667",
  "MAIN <Supervisor password>",
  "  Identifies you as a supervisor, enabling admin commands",
  "VIP [new virtual host]",
  "  /quote VIP alone will list current vhosts in the config file",
  "IDENT <newident>",
  "  If your shell has identwd installed, bnc will take advantage of its features, changing your ident",
  "KEEPALIVE",
  "  returns you to bnc if a shell closes you (EXPERIMENTAL)",
  "CONN <server address> [port] [pass]",
  "  Connects you to a real irc server",
  "VDF",
  "  Switches your vhost back to the config default",
  "VN",
  "  Switches your vhost to the shells default",

  NULL
};
char *helplista[] =  
{
  "-----ADMIN *ONLY* COMMANDS----",
  "BWHO",
  "  Lists all clients using BNC",
  "BKILL <FD>",
  "  Closes one of the clients with that specified FD",
  "DIE",
  "  Shuts down BNC",
  "BDIE",
  "  alternative shutdown",
  "ADDHOST <type> <address>",
  "  Adds an allow for an IP to use your BNC",
  "LISTHOST",
  "  Lists allowed IP hosts",
  NULL
};




BUILTIN_COMMAND(cmd_quit);
BUILTIN_COMMAND(cmd_nick);
BUILTIN_COMMAND(cmd_pass);
BUILTIN_COMMAND(cmd_user);
BUILTIN_COMMAND(cmd_help);
BUILTIN_COMMAND(cmd_main);
BUILTIN_COMMAND(cmd_conn);
BUILTIN_COMMAND(cmd_ident);
BUILTIN_COMMAND(cmd_vn);
BUILTIN_COMMAND(cmd_vdf);
BUILTIN_COMMAND(cmd_vip);
BUILTIN_COMMAND(cmd_who);
BUILTIN_COMMAND(cmd_die);
BUILTIN_COMMAND(cmd_bdie);
BUILTIN_COMMAND(cmd_bkill);
BUILTIN_COMMAND(cmd_addhost);
BUILTIN_COMMAND(cmd_listhost);
BUILTIN_COMMAND(cmd_keepalive);
cmdstruct bnccmds[] =
{
	{ "QUIT", cmd_quit },
	{ "PASS", cmd_pass },
	{ "NICK", cmd_nick },
 	{ "USER", cmd_user },
 	{ "PASS", cmd_pass },
 	{ "HELP", cmd_help },
 	{ "MAIN", cmd_main },
 	{ "CONN", cmd_conn },
 	{ "IDENT", cmd_ident },
 	{ "VN", cmd_vn },
 	{ "VDF", cmd_vdf },
 	{ "VIP", cmd_vip },
 	{ "BWHO", cmd_who },
 	{ "DIE", cmd_die },
 	{ "BDIE", cmd_bdie },
 	{ "BKILL", cmd_bkill },
 	{ "ADDHOST", cmd_addhost },
 	{ "LISTHOST", cmd_listhost },
 	{ "KEEPALIVE", cmd_keepalive },
	{ NULL, NULL }
};

int remnl (char *buf, int size)
{
	int p;

	for (p = 0; p < size; p++)
	{
		if (buf[p] == '\0')
		{
			return p;
		}
		if((buf[p] == '\n') || (buf[p] == '\r'))
		{
			buf[p] = '\0';
			return p;
		}
	}
	return p;
}

int irc_connect(struct cliententry *list_ptr, char *server, u_short port, char *pass)
{
	int cs;
	
	list_ptr->a=0;
	list_ptr->susepass=0;
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Making reality through %s port %i\n", list_ptr->nick, server, port);
	cs = do_connect (list_ptr->vhost, server, port, list_ptr->uname);
	if (cs < 0)
	{
		if (cs == -9)
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Failed Connection (Supplied Vhost is not on this system)\n", list_ptr->nick);
		}
		else
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Failed Connection\n", list_ptr->nick);
		}
		return -1;
	}
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Suceeded connection\n", list_ptr->nick);
	logprint(jack, "(%i) %s!%s@%s connected to %s", list_ptr->fd, list_ptr->nick, list_ptr->uname, list_ptr->fromip, server);

	if (pass != NULL)
	{
		sockprint(cs, "PASS :%s\n", pass);
	}
	strncpy (list_ptr->onserver, server, HOSTLEN);
	list_ptr->onserver[HOSTLEN]='\0';
	sockprint(cs, "NICK %s\n", list_ptr->nick);
	sockprint(cs, "USER %s \"%s\" \"%s\" :%s\n", list_ptr->uname, list_ptr->fromip, list_ptr->onserver, list_ptr->realname);
	list_ptr->sfd = cs;
	list_ptr->c=1;
	return 0;

}



int handlepclient (struct cliententry *list_ptr, int pargc, char **pargv)
{
	int p,f;
	FILE *motdf;
	p=0;
	f=0;
	
	
	p=0;
	while(bnccmds[p].name != NULL)
	{
		if(!strcasecmp(pargv[0],bnccmds[p].name))
		{
			f=bnccmds[p].func(list_ptr,pargc,pargv);
			break;
		}
		p++;
	}
	if(f > 0)
	{
		return f;
	}	
	if((list_ptr->n == 0) || (list_ptr->u == 0) || (list_ptr->p == 0))
	{
		return 0;
	}

	if (list_ptr->b == 0)
	{
		list_ptr->b = 1;
		if (list_ptr->a)
		{
			/* handle the autoconn stuff, disabled for now */
			if (list_ptr->susepass)
			{
				irc_connect(list_ptr, list_ptr->autoconn, list_ptr->sport, list_ptr->autopass);
			}
			else
			{
				irc_connect(list_ptr, list_ptr->autoconn, list_ptr->sport, NULL);
			}
 			
			return 0;

		}
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Welcome to BNC " VERSION ", the irc proxy\n", list_ptr->nick);
		if(list_ptr->s == 0)
		{      
			motdf = fopen (jack->motdf, "r");
			if(motdf != NULL)
			{
				while (!feof (motdf))
				{
					memset(motdb,0,MAXMOTDLINE);
					fgets (motdb,MAXMOTDLINE, motdf);
					motdb[MAXMOTDLINE]='\0';
					p=remnl (motdb,MAXMOTDLINE);
					motdb[MAXMOTDLINE]='\0';
				
					if(p > 0)
					{
						sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :-*- %s\n", list_ptr->nick, motdb);
					}
				}
				fclose (motdf);
			}
		}
	        sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Level two, lets connect to something real now\n", list_ptr->nick);
	        sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :type /quote conn [server] <port> <pass> to connect\n", list_ptr->nick);
	        sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :type /quote help for basic list of commands and usage\n", list_ptr->nick);
	}
	return 0;
}




BUILTIN_COMMAND(cmd_quit)
{
	return 100;
}

BUILTIN_COMMAND(cmd_nick)
{
	if(pargc < 2)
	{
		return 0;
	}
	strncpy (list_ptr->nick, pargv[1], NICKLEN);
	list_ptr->nick[NICKLEN]=0;
	list_ptr->n = 1;
	if (list_ptr->p == 0)
	{
		sockprint(list_ptr->fd,":Bnc!system@bnc.com NOTICE %s :You need to say /quote PASS <password>\n", list_ptr->nick);
	}
	return 0;
}
BUILTIN_COMMAND(cmd_pass)
{
	int p;
	int iswhite;
	int sargc;
	char *sargv[4];
	
	if (pargc < 2)
	{
		return 0;
	}
	if (list_ptr->p)
	{
		return 0;
	}
	
	p = 0;
	sargc=1;
	sargv[0]=pargv[1];
	
	iswhite=0;
	for(p=0; pargv[1][p] ; p++)
	{
		if(sargc > 3)
		{
			iswhite=0; /* just be mean */
		}

		if(iswhite)
		{
			if( pargv[1][p] != ':' )
			{
				iswhite=0;
				sargv[sargc++]=&pargv[1][p];
			}
		}
		else 
		{
			if( pargv[1][p] == ':' )
			{
				iswhite=1;
				pargv[1][p]='\0';
			}
		}
	
	}

/*	
	printf("Pass line gave %i args\n",sargc);
	for(p=0;p<sargc;p++)
	{
		printf("(%i) %s\n",p,sargv[p]); 
	}
*/
	

	/* go back to the old way for now */
	if(passwordokay (sargv[0], jack->dpass))
	{
		list_ptr->p = 1;
		if(sargc > 1)
		{
			list_ptr->a = 1;
			strncpy (list_ptr->autoconn, sargv[1], HOSTLEN);
			list_ptr->autoconn[HOSTLEN]='\0';
			list_ptr->sport=jack->cport;
			if(sargc > 2) /* contains port */
			{
				list_ptr->sport=atoi(sargv[2]);
			}
			if(sargc > 3) /* contains server pass */
			{
				strncpy (list_ptr->autopass, sargv[3], PASSLEN);
				list_ptr->autopass[PASSLEN]='\0';
				list_ptr->susepass=1;
			}
		}
	
		
		return 0;
	}
	list_ptr->pfails++;
	if (list_ptr->pfails > 2)
	{
		return 100;
	}
	logprint(jack, "Failed pass from %s password %s", list_ptr->fromip, sargv[0]);
	if (list_ptr->n)
	{
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Failed Pass!!\n", list_ptr->nick);
	}
	return 0;
}
BUILTIN_COMMAND(cmd_user)
{
	if (pargc < 5)
	{
		return 0;
	}

	strncpy (list_ptr->realname, pargv[4], REALLEN);
	list_ptr->realname[REALLEN]='\0';	

	strncpy (list_ptr->uname, pargv[1], USERLEN);
	list_ptr->uname[USERLEN]='\0';
	  
	list_ptr->u = 1;
	return 0;
}
BUILTIN_COMMAND(cmd_help)
{
	int p;
	if (list_ptr->b == 0)
	{
		return 0;
	}
	for (p = 0; helplist[p] != NULL; p++)
	{
		sockprint(list_ptr->fd,":Bnc!system@bnc.com NOTICE %s :*** %s\n", list_ptr->nick, helplist[p]);
	}
	if(list_ptr->s == 1)
	{
		for (p = 0; helplista[p] != NULL; p++)
		{
			sockprint(list_ptr->fd,":Bnc!system@bnc.com NOTICE %s :*** %s\n", list_ptr->nick, helplista[p]);
		}
	}
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :*** For a detailed explanation of commands, consult the file README,\n", list_ptr->nick);
	return 0;
}

BUILTIN_COMMAND(cmd_main)
{
	if (list_ptr->n == 0)
	{
		return 0;
	}
	if (pargc < 2)
	{
		return 0;
	}
	if (passwordokay (pargv[1], jack->spass))
	{
		list_ptr->s = 1;
		list_ptr->p = 1;
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Welcome Supervisor!!\n", list_ptr->nick);
	    return 0;
	}
	logprint(jack, "Failed MAIN from %s", list_ptr->fromip);
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Failed Main!!\n", list_ptr->nick);

	return 0;
}
BUILTIN_COMMAND(cmd_conn)
{
	int cport;
	
	if (list_ptr->b == 0)
	{
		 return 0;
	}

	if (pargc < 2)
	{
		return 0;
	}
	if (pargc > 2)
	{
		cport = atoi (pargv[2]);
	}
	else
	{
		cport = jack->cport;
	}
	if (pargc > 3)
	{
		irc_connect(list_ptr, pargv[1], cport, pargv[3]);
	}
	else
	{
		irc_connect(list_ptr, pargv[1], cport, NULL);
	}
	return 0;
}

BUILTIN_COMMAND(cmd_ident)
{
	if (list_ptr->b == 0)
	{
		return 0;
	}
	if (pargc < 2)
	{
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :current ident is %s\n", list_ptr->nick, list_ptr->uname);
		return 0;
	}
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :changing ident from %s to %s\n", list_ptr->nick, list_ptr->uname, pargv[1]);
	strncpy (list_ptr->uname, pargv[1], USERLEN);
	list_ptr->uname[USERLEN]='\0';
	return 0;
}
BUILTIN_COMMAND(cmd_vn)
{
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Nulling out Vhost to system internal default\n", list_ptr->nick);
	memset (list_ptr->vhost, '\0',HOSTLEN);
	return 0;
}

BUILTIN_COMMAND(cmd_vdf)
{
	if (strlen (jack->vhostdefault) < 1)
	{
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Switching Vhost back to default\n", list_ptr->nick);
	}
	else
	{
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Switching Vhost back to default (%s)\n", list_ptr->nick, jack->vhostdefault);
	}
	strncpy (list_ptr->vhost, jack->vhostdefault, HOSTLEN);
	list_ptr->vhost[HOSTLEN]='\0';
	return 0;
}
BUILTIN_COMMAND(cmd_vip)
{
	int f;
	struct vhostentry *vhost_ptr;
	struct hostent *he;
	struct in_addr addr;
	
	if (list_ptr->n == 0)
	{
		return 0;
	}
	if (list_ptr->p == 0)
	{
		return 0;
	}
	  
	f = 0;
	if (pargc > 1)
	{
		he = gethostbyname (pargv[1]);
		if (he)
		{
			memcpy (&addr.s_addr, he->h_addr, sizeof (addr.s_addr));
			strncpy (list_ptr->vhost, pargv[1], HOSTLEN);
			list_ptr->vhost[HOSTLEN]='\0';
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Switching Vhost to %s (%s)\n", list_ptr->nick, list_ptr->vhost, inet_ntoa (addr));
		}
		else
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Vhost %s invalid\n", list_ptr->nick, pargv[1]);
		}

	}
	else
	{	
		if (strlen (list_ptr->vhost) != 0)
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Default Vhost: %s\n", list_ptr->nick, list_ptr->vhost);
		}
		else
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Default Vhost: -SYSTEM DEFAULT-\n", list_ptr->nick);
		}
		
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Listing Vhosts\n", list_ptr->nick);
		vhost_ptr=jack->vhostlist;
	      
		while (vhost_ptr != NULL)
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s : (%i) %s\n", list_ptr->nick, f, vhost_ptr->vhost);
			f++;
			vhost_ptr = vhost_ptr->next;
		}
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :End of Vhost list\n", list_ptr->nick);
	}
	return 0;
}
BUILTIN_COMMAND(cmd_who)
{
	struct cliententry *client_ptr;
	char st[10];
	if (list_ptr->s == 0)
	{
		return 0;
	}    
	client_ptr = headclient;
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Listing users.\n", list_ptr->nick);
	while (client_ptr != NULL)
	{
		thestat(st,10, client_ptr);
		if( client_ptr->c )
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :(FD %i Status: %s)[%s@%s] on server %s\n", list_ptr->nick, client_ptr->fd, st, client_ptr->nick, client_ptr->fromip, client_ptr->onserver);
		}
		else
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :(FD %i Status: %s)[%s@%s] \n", list_ptr->nick, client_ptr->fd, st, client_ptr->nick, client_ptr->fromip);
		}
		client_ptr = client_ptr->next;
	}
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :End of user list.\n", list_ptr->nick);
	return 0;
}
BUILTIN_COMMAND(cmd_bdie)
{
 	if (list_ptr->s == 0)
	{
		return 0;
	}
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Shutting it down....\n", list_ptr->nick);
	logprint(jack,"Shutdown called by %s@%s",list_ptr->nick,list_ptr->fromip);
	bnckill(FATALITY);
	return 0;
}
BUILTIN_COMMAND(cmd_die)
{
	if (list_ptr->s == 0)
	{
		return 0;
	}
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Shutting it down....\n", list_ptr->nick);
	logprint(jack,"Shutdown called by %s@%s",list_ptr->nick,list_ptr->fromip);
	bewmstick ();
	return 0;
}

BUILTIN_COMMAND(cmd_bkill)
{
	int p;
	struct cliententry *client_ptr;
	if (list_ptr->s == 0)
	{
		return 0;
	}
	if (pargc < 2)
	{
		return 0;
	}
	p = atoi (pargv[1]);
	if(p < 1)
	{
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :invalid bkill argument\n", list_ptr->nick);
		return 0;
	}
	client_ptr = getclient(headclient,p);
	if( client_ptr == NULL)
	{
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :No such FD %i\n", list_ptr->nick, p);		          
		return 0;
	}

	if(p == list_ptr->fd)
	{
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Suicide is painful\n", list_ptr->nick);
		return 100;
	}
	sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Killed %i\n", list_ptr->nick, p);
	logprint(jack, "BKILL to %s@%s", client_ptr->nick, client_ptr->fromip);
	headclient=delclient(headclient,p);
	return 0;
}

BUILTIN_COMMAND(cmd_addhost)
{
	accesslist *na;

	if (list_ptr->s == 0)
	{
		return 0;
	}
	if (pargc < 3)
	{
		return 0;
	}
	if (atoi (pargv[1]) > 2)
	{
		return 0;
	}
	na = malloc (sizeof (accesslist));
	na->type = atoi (pargv[1]);
	strncpy (na->addr, pargv[2], HOSTLEN);
	na->addr[HOSTLEN]='\0';
	na->next = NULL;
	add_access (jack, na);
	logprint(jack, "ADDHOST %s", pargv[2]);
	return 0;
}

BUILTIN_COMMAND(cmd_listhost)
{
	accesslist *na;
	int i;

	if (list_ptr->s == 0)
	{
		return 0;
	}
	for (na = jack->alist, i = 1; na; na = na->next, i++)
	{
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :#%i: (t:%i) %s\r\n", list_ptr->nick, i, (int) na->type, na->addr);
	}
	return 0;
}

BUILTIN_COMMAND(cmd_keepalive)
{
	if(list_ptr->p == 0)
	{
		return 0;
	}
	if(list_ptr->k == 0)
	{
		list_ptr->k=1;
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Enabling KeepAlive\n", list_ptr->nick);
	}
	else
	{
		list_ptr->k=0;
		sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :Disabling KeepAlive\n", list_ptr->nick);
	}
	return 0;
}