#include "config.h"

#define BUFSIZE 512
#define PASSLEN 16
#define HOSTLEN 63
#define NICKLEN 30
#define USERLEN 10
#define REALLEN 50
#define AUTOCON 1024

struct cliententry
{
  struct cliententry *next;
  char nick[NICKLEN + 1];
  char uname[USERLEN + 1];
  char fromip[HOSTLEN + 1];
  char realname[REALLEN + 1];
  char vhost[HOSTLEN + 1];
  char onserver[HOSTLEN + 1];
  char autoconn[HOSTLEN + 1];
  char autopass[PASSLEN + 1];
  int sport;
  int susepass;
  unsigned int
    u:1, p:1, n:1, s:1, b:1, a:1, c:1, k:1;
  int fd;
  int sfd;
  int pfails;
  int blen;
  char biff[BUFSIZE];

};

#define BUILTIN_COMMAND(x) int x(struct cliententry *list_ptr, int pargc, char **pargv)

typedef struct
{
   char *name;
   int (*func)(struct cliententry *, int, char **);
} cmdstruct;


struct vhostentry
{
    struct vhostentry  *next;
    char vhost[HOSTLEN+1];   
    
};

struct alist_struct {
	char type;
	char addr[HOSTLEN+1];
	struct alist_struct *next;
};
typedef struct alist_struct accesslist;

typedef struct
{
    char pidfile[256];
    unsigned int dport;
    unsigned int maxusers;
    char dpass[PASSLEN+1];
    int dpassf;
    unsigned int cport;
    int identwd;
    int logf;
    FILE *logfile;
    FILE *identlie;
    struct vhostentry *vhostlist;
    accesslist *alist, *alist_end;
    int has_alist;
    char vhostdefault[HOSTLEN+1];
    char spass[PASSLEN+1];
    int usemotd;
    char motdf[256];
} confetti;

#define CONFNOTFOUND 1
#define CONFREQNOTHAPPY 2
#define FATALITY 255
#define SOCKERR 3
#define BINDERR 4
#define LISTENERR 5
#define FORKERR 6
#define BACKGROUND 7
#define SELECTERR 8
#define KILLED 9
#define DOWNER 10
