#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <stdarg.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <netdb.h>
#include <pwd.h>

#include "common.h"
#define ENDLESSLOOP for(;;)


extern h_errno;
extern char logbuf[];
extern int bnclog (confetti * jr, char *logbuff);
extern void add_access (confetti *, accesslist *);
extern int handlepclient (struct cliententry *list_ptr, int pargc, char **pargv);
extern void bnckill (int reason);
extern int remnl (char *buf, int size);

extern char *helplist[];
extern char *helplista[]; 

int highfd;
int a_sock = 0;
int s_sock = 0;
struct sockaddr_in muhsin;
struct sockaddr wipi;
int sinlen;

int allbuflen;
unsigned char allbuf[1024];
int bufs;
unsigned char buffer[1024];

extern unsigned char motdb[];

struct cliententry *headclient;
confetti *jack;


char *commands[] =
{
  "NICK", "PASS", "USER", "MAIN",
  "VIP", "CONN", "BWHO", "BKILL",
  "VDF", "VN", "DIE", "ADDHOST",
  "LISTHOST", "BDIE", "HELP", "IDENT","QUIT", NULL
};

#define NICK 0
#define PASS 1
#define USER 2
#define MAIN 3
#define VIP 4
#define CONN 5
#define BWHO 6
#define BKILL 7
#define VDF 8
#define VN 9
#define DIE 10
#define ADDHOST 11
#define LISTHOST 12
#define BDIE 13			/* hehe unlucky 13? */
#define BHELP 14
#define BIDENT 15
#define UQUIT 16














#ifndef HAVE_SNPRINTF
#ifdef HAVE_VSNPRINTF
int snprintf(char *str, size_t n, const char *format,...)
{
  int p;
  va_list ap;
  va_start (ap, format);
  p = vsnprintf(char *str, size_t n, const char *format,
  va_end(ap);
  return p;
}
#else
#define BADBUF 4096
char mybuf[BADBUF+1];		/* dumb but oh well, attempting securety : */

int snprintf (char *str, size_t n, const char *format,...)
{
  int p;
  va_list ap;

  va_start (ap, format);

  p = vsprintf (mybuf, format, ap);
  va_end (ap);
  if(n > BADBUF)
  {
    n = BADBUF;
  }
  strncpy (str, mybuf, n);
  str[n]='\0';
  if (p > n)
  {
    p = n;
  }
  return p;
}

int vsnprintf ( char *str, size_t n, const char *format, va_list ap )
{
  int p;
  p = vsprintf (mybuf, format, ap);
  if(n > BADBUF)
  {
    n = BADBUF;
  }
  strncpy (str, mybuf, n);
  str[n]='\0';
  if (p > n)
  {
    p = n;
  }
  return p;
}
#endif
#endif


int sockprint(int fd,const char *format,...)
{
  int p;
  va_list ap;
  va_start(ap,format);
  p = vsnprintf(buffer, 1024, format, ap);
  va_end(ap);
  send(fd, buffer, p, 0);
  return p;
}

int logprint(confetti *jr,const char *format,...)
{
  int p;
  va_list ap;
  va_start(ap,format);
  p = vsnprintf(buffer, 1024, format, ap);
  va_end(ap);
  bnclog(jr,buffer);
  return p;
}


int thestat(char *buf,int len, struct cliententry *list_ptr)
{
  int p,c;
  char st[2][9] = 
  {
    { 's','p','u','n','b','a','c','k', 0 },
    { 'S','P','U','N','B','A','C','K', 0 },
  };
  for(p=0;st[0][p];p++)
  {
    if(p+1 >= len)
    {
      buf[p]='\0';
      break;
    }
    else
    {
      c=0;
      switch(p)
      {
        case 0:
        {
          c=list_ptr->s;
          break;
        }
        case 1:
        {
          c=list_ptr->p;
          break;
        }
        case 2:
        {
          c=list_ptr->u;
          break;
        }
        case 3:
        {
          c=list_ptr->n;
          break;
        }
        case 4:
        {
          c=list_ptr->b;
          break;
        }
        case 5:
        {
          c=list_ptr->a;
          break;
        }
        case 6:
        {
          c=list_ptr->c;
          break;
        }
        case 7:
        {
          c=list_ptr->k;
        }
      }
      buf[p]=st[c][p];
    }
  }
  buf[p]='\0';
  return p;
}

/*
 * experimental matching code (WD) I hope this runs faster, who knows...
 */

int check_match (char *mask)
{
  if (!index (mask, '*') && !index (mask, '?'))
    return 0;
  else if (!strcmp (mask, "*"))
    return 1;
  else
    return 2;
}

/*
 * Note, thanx to RogerY and Redtrio for this wonderful code.  Please
 * keep this notice intact.  -- TazQ 
 */

/*
 * My wildcard matching functions. I think it works well :) Seems to be 
 */
/*
 * working stablely, but not too sure.                                  
 */
int
  match (char *str, char *wld)
{
  int i = check_match (wld);

  switch (i)
  {
    case 0:
      return strcasecmp (str, wld);
      break;
    case 1:
      return 0;
      break;
  }

  if (!(*wld) || !(*str))
    return 1;
  while (*wld || *str)
  {
    if (tolower (*wld) == tolower (*str))
    {
      wld++;
      str++;
    }
    else if (tolower (*wld) != tolower (*str) && *wld == '*')
    {
      int i = 0;
      char *st;

      st = (char *) malloc( sizeof(char) * strlen(wld) + 1);

      while (*wld == '*' && *wld)
      {
	wld++;
	if (!*wld)
	  return 0;
      }
      while (*wld && *wld != '*' && *wld != '?')
      {
	st[i] = *wld;
	i++;
	wld++;
      }
      st[i] = '\0';
      while (*str && strncasecmp (st, str, strlen (st)))
	str++;
      if (!strncasecmp (st, str, strlen (st)))
	str += strlen (st);
      else
	return 1;
    }
    else if (tolower (*wld) != tolower (*str) && *wld == '?' && *wld && *str)
    {
      wld++;
      str++;
    }
    else if (tolower (*wld) != tolower (*str))
      return 1;
  }
  return 0;
}




int passwordokay (char *s, char *pass)
{

  char *encr;
  char salt[3];
  char *crypt ();

  if (pass[0] == '+')
  {
    pass = &pass[1];

    salt[0] = pass[0];
    salt[1] = pass[1];
    salt[2] = 0;
    encr = crypt (s, salt);
  }
  else
  {
    encr = s;
  }

  if (!strncmp (encr, pass, 10))
    return 1;
  else
    return 0;
}

int connokay (struct sockaddr_in sa, confetti * jr)
{
  struct hostent *hp = gethostbyaddr ((char *) &sa.sin_addr, sizeof (sa.sin_addr), AF_INET);

  accesslist *na;

  logprint(jack, "Connection from %s", inet_ntoa (sa.sin_addr));

  if (!jr->has_alist)
    return 1;
  for (na = jr->alist; na; na = na->next)
  {
    if (na->type == 1)
    {
      if (!match (inet_ntoa (sa.sin_addr), na->addr))
	return 1;
    }
    else if (na->type == 2 && hp)
    {
      if (!match (hp->h_name, na->addr))
	return 1;
    }
  }
  return 0;
}




int wipeclient(struct cliententry *list_ptr)
{
	if(list_ptr->fd > -1)
	{
		close(list_ptr->fd);
	}
	if(list_ptr->sfd > -1)
	{
		close(list_ptr->sfd);
	}
	free(list_ptr);
	return 0;
}

int freeclientlist (struct cliententry *list_ptr)
{
  struct cliententry *hold_ptr;

  while (list_ptr != NULL)
  {
    hold_ptr = list_ptr->next;
    wipeclient(list_ptr);
    list_ptr = hold_ptr;
  }
  return 1;
}

int bewmstick (void)
{
  freeclientlist(headclient);
  headclient = NULL;
  bnckill(FATALITY);
  return 0;
}

struct cliententry *delclient(struct cliententry *client_ptr, int nfd)
{
	struct cliententry *list_ptr;
	struct cliententry *last_ptr;
	if(client_ptr == NULL)
	{
		return client_ptr;
	}
	if( (client_ptr->fd == nfd) || (client_ptr->sfd == nfd))
	{
		list_ptr=client_ptr->next;
		wipeclient(client_ptr);
		return list_ptr;
	}

	last_ptr = client_ptr;
	list_ptr = last_ptr->next;
	while( list_ptr != NULL)
	{
		if( (list_ptr->fd == nfd) || (list_ptr->sfd == nfd))
		{
			last_ptr->next=list_ptr->next;
			wipeclient(list_ptr);
			return client_ptr;
		} 
		last_ptr=list_ptr;
		list_ptr=list_ptr->next;
	}
	return client_ptr;
}

int getother (struct cliententry *list_ptr, int nfd)
{
  while (list_ptr != NULL)
  {
    if( list_ptr->c )
    {
      if (list_ptr->fd == nfd)
      {
        return list_ptr->sfd;
      } 
      if (list_ptr->sfd == nfd)
      {
        return list_ptr->fd;
      }
    }
    list_ptr = list_ptr->next;
  }
  return -1;

}

struct cliententry *getclient (struct cliententry *list_ptr, int nfd)
{
	while (list_ptr != NULL)
	{
		if (list_ptr->fd == nfd)
		{
			return list_ptr;
		}
		if (list_ptr->sfd == nfd)
		{
			return list_ptr;
		}
		list_ptr = list_ptr->next;
	}
	return NULL;
}

int countfds (struct cliententry *list_ptr)
{
	int p;

	p = 0;
	while (list_ptr != NULL)
	{
		list_ptr = list_ptr->next;
		p++;
	}
	return p;
}

char *gethost (struct in_addr *addr)
{
	struct hostent *hp;

	hp = gethostbyaddr ((char *) addr, sizeof (struct in_addr), AF_INET);
	if(hp)
	{
		return hp->h_name;
	}
	return inet_ntoa (*addr);
}


int do_connect (char *vhostname, char *hostname, u_short port, char *uname)
{
	int s;
	int f;
	struct hostent *he;
	struct sockaddr_in sin;

	f = 1;
	s = socket (AF_INET, SOCK_STREAM, 0);
	if (s < 0)
	{
		return -2;
	}
	memset (&sin, 0, sizeof (struct sockaddr_in));
	sin.sin_family = AF_INET;

	if( (vhostname == NULL))
	{
		f = 0;
	}
	else
	{
		if (strlen (vhostname) < 1)
		{
			f = 0;
		}
	}

	sin.sin_addr.s_addr = (f ? inet_addr (vhostname) : INADDR_ANY);
	if ((sin.sin_addr.s_addr == -1) && f)
	{
		he = gethostbyname (vhostname);
		if (he)
		{
			memcpy (&sin.sin_addr, he->h_addr, he->h_length);
		}
	}
	else
	{
		sin.sin_addr.s_addr = INADDR_ANY;
	}

	if (bind (s, (struct sockaddr *) &sin, sizeof (struct sockaddr_in)) < 0)
	{
		return -9;
	}
	memset (&sin, 0, sizeof (struct sockaddr_in));
	sin.sin_family = AF_INET;
	sin.sin_port = htons (port);
	sin.sin_addr.s_addr = inet_addr (hostname);
	if (sin.sin_addr.s_addr == -1)
	{
		he = gethostbyname (hostname);
		if (!he)
		{
			return -1;
		}
		memcpy (&sin.sin_addr, he->h_addr, he->h_length);
	}
	if (jack->identwd)
	{
		FILE *fp = NULL;
		struct passwd *pw = getpwuid (getuid ());
		char filename[1024];

		sprintf (filename, "%s/.identwd/%s.%i.LOCK",
		pw->pw_dir, inet_ntoa (sin.sin_addr), port);
		fp = fopen (filename, "w");
		if (fp)
		{
			fprintf (fp, "WAIT\n");
			fclose(fp);
		}
	}

	if (connect (s, (struct sockaddr *) &sin, sizeof (sin)) < 0)
	{
		close(s);
		return -2;
	}
	if (jack->identwd)
	{
		FILE *fp = NULL;
		struct passwd *pw = getpwuid (getuid ());
		char filename[1024];

		sprintf (filename, "%s/.identwd/%s.%i.LOCK",
		pw->pw_dir, inet_ntoa (sin.sin_addr), port);
		fp = fopen (filename, "w");
		if (fp)
		{
			int len = sizeof (struct sockaddr_in);
			struct sockaddr_in mysa;

			getsockname (s, (struct sockaddr *) &mysa, &len);
			fprintf (fp, (char *) "%s %i %s\n",
			(char *) inet_ntoa (mysa.sin_addr),
			(u_short) ntohs (mysa.sin_port), uname);
			fclose(fp);
		}
	}
	return s;
}


/* trust the caller of handleclient to filter \0 \n and \r
 * expects buflen be the len of the string, not counting the \0
 * also expects a \0 to be prepended.
 */ 

int handleclient (struct cliententry *list_ptr, int buflen, char *buf)
{
	int p, f;
	char *pargv[10];
	int pargc;
	int iswhite;
	p=0;
	f=0;
	pargv[0]=buf;
	pargc=1;
	
	iswhite=0; 
	for(p=0;p<buflen;p++)
	{
		if(iswhite) /* inside the whitespace */
		{
			if( buf[p] == ':' )
			{
				pargv[pargc]=&buf[p+1];
				pargc++;
				break; /* hit a string, meaning done */
			}
			if(buf[p] != ' ')
			{
				iswhite=0; /* no longer white */
				pargv[pargc]=&buf[p];
				pargc++;
				if(pargc > 9)
				{
					break;
				}
			}
		}
		else
		{
			if(buf[p] == ' ' )
			{
				buf[p]='\0';
				iswhite=1;
			}
		}
	}
	return handlepclient(list_ptr, pargc, pargv);
	
}

/*
int handleclient (struct cliententry *list_ptr, int buflen, char *buf)
{
	int p, f;
	char *pargv[100];
	char *tmp;

	p = 0;
	f = 0;
	tmp = strtok (buf, " \n\r");
	if (tmp != NULL)
	{
		pargv[p++] = tmp;
		while ((tmp = strtok (NULL, " \n\r")) != NULL)
		{
			pargv[p++] = tmp;
			if (p > 100)
			break;
		}
		f = handlepclient(list_ptr, p, pargv);
	}
	return f;
}
*/

void initclient (struct cliententry *list_ptr, fd_set * nation)
{
	highfd = s_sock;
	FD_ZERO (nation);
	FD_SET (s_sock, nation);
	while (list_ptr != NULL)
	{
		FD_SET(list_ptr->fd, nation);
		if (list_ptr->fd > highfd)
		{
			highfd = list_ptr->fd;
		}
		if(list_ptr->c)
		{
			FD_SET(list_ptr->sfd,nation);
			if (list_ptr->sfd > highfd)
			{
				highfd = list_ptr->sfd;
			}	
		}
		list_ptr = list_ptr->next;
	}
}

int scancon (struct cliententry *list_ptr, fd_set * nation)
{
	if (FD_ISSET (list_ptr->fd, nation))
	{
		allbuflen = recv (list_ptr->fd, allbuf, 1024, 0);
		if (allbuflen <= 0)
		{
			return 100;
		}
		send (list_ptr->sfd, allbuf, allbuflen, 0);
	}
	if (FD_ISSET (list_ptr->sfd, nation))
	{
		allbuflen = recv (list_ptr->sfd, allbuf, 1024, 0);
		if (allbuflen <= 0)
		{
			if(list_ptr->k)
			{
				return 300;
			}
			else
			{
				return 100;
			}
		}
		send (list_ptr->fd, allbuf, allbuflen, 0);
	}
	return 0;
}

int scanclient (struct cliententry *list_ptr, fd_set * nation)
{
	int p,c,f;

	if (FD_ISSET (list_ptr->fd, nation))
	{
		allbuflen = recv (list_ptr->fd, allbuf, 1024, 0);
		if (allbuflen <= 0)
		{
			return list_ptr->fd;
		}
		for (p = 0; p < allbuflen; p++)
		{
			c=allbuf[p];
			switch(c)
			{
				case '\0':
				{
					break;
				}
				case '\r':
				case '\n':
				{
				        if(list_ptr->blen < BUFSIZE)
				        {
						list_ptr->biff[list_ptr->blen]=0;
						c=list_ptr->blen;
					}
					else
					{
						list_ptr->biff[BUFSIZE-1]=0;
						c=BUFSIZE-1;
					}
					list_ptr->blen=0;
					if(c > 0 )
					{
						f = handleclient (list_ptr, c, list_ptr->biff);
						if( f > 0)
						{
							return f;
						}
					}
					break;
				}
				default:
				{
				        if(list_ptr->blen < (BUFSIZE-1))
				        {
					  list_ptr->biff[list_ptr->blen++]=c;
					}
					break;
				}
			}
		}	
	}
	return 0;
}

struct cliententry *chkclient (struct cliententry *list_ptr, fd_set * nation)
{
	int p;

	while (list_ptr != NULL)
	{
		if(list_ptr->c)
		{
			p=scancon(list_ptr,nation);
		}
		else
		{
			p=scanclient(list_ptr,nation);	
		}
		if(p == 100) /* self death */
		{
			return list_ptr;
		}
		if(p == 300) /* keep alive */
		{
			sockprint(list_ptr->fd, ":Bnc!system@bnc.com NOTICE %s :IRC quit, KeepAlive here.\n", list_ptr->nick);
			if(list_ptr->c)
			{
				list_ptr->c=0;
				if(list_ptr->sfd)
				{
					close(list_ptr->sfd);
				}
			}
		}
		list_ptr = list_ptr->next;
	}
  	return NULL;
}

void doclient(struct cliententry *list_ptr, fd_set * nation)
{
	int citizen, p;
	struct in_addr faddr;
	struct cliententry *bob;

	if (FD_ISSET (s_sock, nation))
	{
		citizen = accept (s_sock, (struct sockaddr *) &muhsin, &sinlen);
		if (citizen >= 0)
		{
			if (jack->maxusers)
			{
				if (countfds (headclient) + 1 > jack->maxusers)
				{
					close (citizen);
					return;
				}
			}
			p = sizeof (muhsin);
			getpeername (citizen, (struct sockaddr *) &muhsin, &p);
			if (!connokay (muhsin, jack))
			{
				close (citizen);
				return;
			}
			bob = (struct cliententry *) malloc( sizeof( struct cliententry ));
			memset(bob, 0, sizeof(struct cliententry));
			if( bob == NULL)
			{
				close (citizen);
				return;
			}
			bob->fd = citizen;
			bob->sfd = -1;
			bob->next=headclient;
			headclient=bob;
			strncpy(bob->vhost, jack->vhostdefault, HOSTLEN);
			bob->vhost[HOSTLEN]='\0';
			strcpy(bob->nick,"UNKNOWN");

			faddr = muhsin.sin_addr;
			strncpy (bob->fromip, gethost (&faddr), HOSTLEN);
			bob->fromip[HOSTLEN]='\0';

			if (jack->dpassf == 0)
			{
				bob->p = 1;
			}
			bob->blen=0;
		}
	}
	/* normal connection stuff */
	bob = chkclient (list_ptr, nation);
	if(bob != NULL)
	{
		headclient = delclient (headclient, bob->fd);
	}
}

int initproxy (confetti * jr)
{
  int f;

  s_sock = socket (AF_INET, SOCK_STREAM, 0);
  if (s_sock < 0)
  {
    return SOCKERR;
  }
  memset (&muhsin, 0, sizeof (struct sockaddr_in));

  muhsin.sin_family = AF_INET;
  muhsin.sin_port = htons (jr->dport);
  muhsin.sin_addr.s_addr = INADDR_ANY;
  f = 1;
  setsockopt (s_sock, SOL_SOCKET, SO_REUSEADDR, &f, sizeof (f));

  if (bind (s_sock, (struct sockaddr *) &muhsin, sizeof (struct sockaddr_in)) < 0)
  {
    close (s_sock);
    return BINDERR;
  }
  if (listen (s_sock, 10) < 0)
  {
    return LISTENERR;
  }
  return 0;
}

int ircproxy (confetti * jr)
{
  int p;
  fd_set nation;

  jack = jr;
  ENDLESSLOOP
  {
    initclient(headclient, &nation);
    if ((p = select (highfd + 1, &nation, (fd_set *) 0, (fd_set *) 0, NULL)) < 0)
    {
      bnckill (SELECTERR);
    }
    doclient (headclient, &nation);
  }
  return 0;
}


